<template>
  <ObModal
    ref="modal"
    :title="title"
    :is-show-controls="true"
    :is-read-only="true"
    cancel-text="Закрыть"
    size="max"
  >
    <div class="modal-info-header">
      <slot />
    </div>

    <ObTable
      ref="table"
      class="scenario-data-table"
      :columns="columns"
      :remote-opt="remoteOpts"
      :functional-panel="true"
      :table-layout-fixed="false"
      :is-functional-sort="false"
      :is-functional-group="false"
      @on-load-list="buildColumns"
    />
  </ObModal>
</template>

<script>
  import ObModal from "common-components/src/obComponents/obModal";
  import ObTable from "common-components/src/obComponents/obTable";
  import { modal_columns } from "../data.js";

  export default {
    name: "tender-scenario-data-modal",
    components: {
      ObModal,
      ObTable
    },
    props: {
      title: {
        type: String,
        required: true
      },
      viewFilter: {
        type: String,
        required: true
      },
      remoteOpts: {
        type: Object,
        required: true
      }
    },
    data () {
      return {
        columns: []
      }
    },
    methods: {
      open() {
        this.$refs.modal.open();

        this.$nextTick(() => {
          this.$nextTick(() => this.$refs.table.loadData({ init: true }));
        });
      },
      buildColumns(lots) {
        switch (this.viewFilter) {
          case "lots":
            this.columns = [...modal_columns.lots];

            break;

          case "contractors": {
            const columns = [...modal_columns.contractors];

            if (lots?.length) {
              const newColumns = lots[0].lotHeaders
                .sort((a, b) => a.categoryPos - b.categoryPos)
                .map(header => {
                  return {
                    title: header.title,
                    headerHtml: () => `<div class="text-gray">${header.categoryTitle}</div>${header.title}`,
                    key: header.uuid,
                    isAlignRight: typeof header.value === 'number',
                    html: (data) => data.lotHeaders.find(h => h.uuid === header.uuid).value
                  }
                });

              columns.splice(5, 0, ...newColumns);

              this.columns = columns;
            }

            break;
          }
        }

        return [];
      }
    }
  }
</script>

<style lang="scss" scoped>
  .modal-info-header {
    display: flex;
    align-items: flex-start;
    margin-bottom: 20px;
  }

  .scenario-data-table {
    border: 1px solid $blue-150;
  }
</style>